////////////////////////////////////////////////////////////////////////////////
//
// Image Picker JavaScript
//
/////////////////////////////////////////////////////////////////////////////////

var xmlHttp = null;

////////////////////////////////////////////////////////////////////////////////
//
// GetXmlHttpObject
//
/////////////////////////////////////////////////////////////////////////////////

function GetXmlHttpObject()
{
  try
  {
    xmlHttp = new XMLHttpRequest();
  }
  catch(e)
  {
    try
    {
      xmlHttp = new ActiveXObject("MSXML2.XMLHTTP");
    }
    catch(e)
    {
      xmlHttp = new ActiveXObject("Microsoft.XMLHTTP");
    }
  }

  if (xmlHttp == null)
    alert("Browser does not support XMLHttpRequest().");

  return xmlHttp;
}

////////////////////////////////////////////////////////////////////////////////
//
// xmlHttpRequest
//
/////////////////////////////////////////////////////////////////////////////////

function xmlHttpRequest(requestURL, requestType)
{
  xmlHttpResponse(requestType);

  xmlHttp = GetXmlHttpObject();
  xmlHttp.onreadystatechange = xmlHttpResponse;
  xmlHttp.open("GET", requestURL, false); // synchronous
  xmlHttp.send(null);
}

////////////////////////////////////////////////////////////////////////////////
//
// xmlHttpResponse
//
/////////////////////////////////////////////////////////////////////////////////

function xmlHttpResponse(requestType)
{
  if (typeof(requestType) == 'string')
  {
    xmlHttpResponse.type = requestType;
    return;
  }
  
  if (xmlHttp.readyState == 4 || xmlHttp.readyState == "complete")
  {
    switch (xmlHttpResponse.type)
    {
      case 'get_image_filenames':
        get_image_filenames.list = xmlHttp.responseText;
        break;

      case 'image_file_exists':
        image_file_exists.state = xmlHttp.responseText == 'true';
        break;

      case 'create_resized_images':
        if (xmlHttp.responseText.substr(0, 7) == 'success')
        {
          var image_sizes = xmlHttp.responseText.split('\n');
          create_resized_images.image_sizes = image_sizes.slice(1);
          reset_image_link_colors(xmlHttpResponse.type, 'blue');
        }
        break;

      case 'delete_image':
        if (xmlHttp.responseText.substr(0, 7) == 'success')
          reset_image_link_colors(xmlHttpResponse.type, 'red');
        break;
    }
  }
}

////////////////////////////////////////////////////////////////////////////////
//
// AddImages
//
/////////////////////////////////////////////////////////////////////////////////

function AddImages(root, imageListID, imageArray, imagePath, imageName)
{
  var dirlist, imagelist;
  var image_dir, path;
  var shopsite_images;
  var image_desc;
  var i;

  if (root == 'http')
  {
    // get the image media path and file name from the URL
    i = imageName.indexOf('/media/');
    if (i > 0)
    {
      imageName = imageName.substr(i + 1);
      i = imageName.lastIndexOf('/');
      if (i > 0)
      {
        imagePath = imageName.substr(0, i);
        imageName = imageName.substr(i + 1);

        if (win32)
        {
          var nameParts = imagePath.split('/');
          imagePath = nameParts[0];
          for (i = 1; i < nameParts.length; i++)
            imagePath += slash + nameParts[i];
        }
      }
    }
  }

  dirlist = document.getElementById('d:' + imageListID);
  imagelist = document.getElementById(imageListID);

  for (i = 0; i < imageArray.length; i++)
  {
    image_dir = imageArray[i];
    dirlist.options[i] = new Option(image_dir, image_dir, false, false);

    if (image_dir == imagePath)
      dirlist.options[i].selected = true;
  }

  if (imagePath.match(/shopsite-images|buttons/i) != null)
    shopsite_images = true;

  if (shopsite_images || imageName.length == 0)
    imagelist.options[0] = new Option(no_image, 'none', true, false);
  else
  {
    path = imagePath + slash + imageName;

    if (path.slice(0, root.length) == root)
      path = path.slice(root.length + 1);

    imagelist.options[0] = new Option(imageName, path, true, false);
  }

  if ((image_desc = document.getElementById('a:' + imageListID)) != null)
  {
    if (!('placeholder' in image_desc))
    {
      var html = '&nbsp;(' + image_desc_label + ')';
      image_desc.insertAdjacentHTML("AfterEnd", html);
    }
  }
}

////////////////////////////////////////////////////////////////////////////////
//
// ListImages
//
/////////////////////////////////////////////////////////////////////////////////

function ListImages(listID, subsystem, media_dir)
{
  var dirList = document.getElementById('d:' + listID);
  var imageList = document.getElementById(listID);
  var imageFileNames, imageName;
  var filenames, filename;
  var images_dir, root;
  var popup = false;
  var path, parts;
  var i, j = 0;

  if (imageList != null)
  {
    imageList.onmousedown = "";

    if ((i = imageList.selectedIndex) >= 0)
      imageName = imageList.options[i].text;
    else
      imageName = '';
  }
  else
    return;

  if (dirList == null)
  {
    dirList = document.getElementById('directories'); // pop-up window
    popup = dirList != null;
  }

  if (dirList != null)
    images_dir = dirList.options[dirList.selectedIndex].value;
  else
  if (arguments.length == 3)
      images_dir = media_dir;
  else
    images_dir = 'media';

  parts = images_dir.split(slash);
  root = parts[0];

  get_image_filenames(images_dir, subsystem);
  imageFileNames = get_image_filenames.list;
  filenames = imageFileNames.split('|');

  imageList.options.length = 0;
  
  if (no_image.length > 0)
    imageList.options[j++] = new Option(no_image, 'none', false, false);
  
  for (i = 0; i < filenames.length; i++)
  {
    filename = filenames[i];
    if (filename.length == 0)
      continue;

    if (!popup)
    {
      path = images_dir + slash + filename;

      if (!button_images)
      {
        if (path.slice(0, root.length) == root)
          path = path.slice(root.length + 1);
      }
    }
    else
      path = filename;

    imageList.options[j] = new Option(filename, path, false, false);

    if (filename == imageName)
      imageList.options[j].selected = true;

    j++;  // don't move this into the for statement
  }

  if (imageList.selectedIndex < 0)
  {
    if (imageList.options.length == 1)
      imageList.options[0].selected = true;
  }
}

////////////////////////////////////////////////////////////////////////////////
//
// RefreshImageList
//
/////////////////////////////////////////////////////////////////////////////////

function RefreshImageList(imageid, imageName, subsystem)
{
  var imageList = document.getElementById(imageid);
  var options = imageList.options;
  var i;

  ListImages(imageid, subsystem);

  for (i = 0; i < options.length; i++)
  {
    if (options[i].text == imageName)
    {
      options[i].selected = true;
      break;
    }
  }

  if (i == options.length)
    options[0].selected = true;  // should be 'none'

  if (arguments.length > 3)
  {
    imageid = arguments[3];
    RefreshImageList(imageid, imageName, subsystem);
  }
}

////////////////////////////////////////////////////////////////////////////////
//
// RefreshMoreInfoImageList
//
/////////////////////////////////////////////////////////////////////////////////

function RefreshMoreInfoImageList(imageid, m_imageid)
{
  var dirList = document.getElementById('d:' + imageid);
  var imageList = document.getElementById(imageid);

  var m_dirList = document.getElementById('d:' + m_imageid);
  var m_imageList = document.getElementById(m_imageid);

  var options, text, value, i;

  // copy the product image list to the moreinfo image list
  options = imageList.options;
  m_imageList.options.length = 0;

  for (i = 0; i < options.length; i++)
  {
    text = options[i].text;
    value = options[i].value;
    m_imageList.options[i] = new Option(text, value, false, false);
  }

  m_dirList.selectedIndex = dirList.selectedIndex;
  m_imageList.selectedIndex = imageList.selectedIndex;
  m_imageList.onmousedown = "";
}

////////////////////////////////////////////////////////////////////////////////
//
// UploadImage
//
/////////////////////////////////////////////////////////////////////////////////

function UploadImage(imageid, subsystem)
{
  var imageList = document.getElementById(imageid);
  var dirList = document.getElementById('d:' + imageid);
  var imagePath = document.getElementById('t:' + imageid);
  var media_dir = null;
  var root, url, i;

  root = subsystem == digital_subsystem? 'downloads' : 'media';

  if (imagePath == null)  // will be null in basic editing mode
    imagePath = document.getElementById(imageid);

  if (dirList == null)
    dirList = document.getElementById('directories'); // pop-up window

  if (dirList != null)
    media_dir = dirList.options[dirList.selectedIndex].value;
  else
  {
    var path = imagePath.value;
    if (path.indexOf('http') != 0 && path.indexOf('shopsite-images') < 0)
    {
      if ((i = path.lastIndexOf(slash)) > 0)
        media_dir = root + slash + path.slice(0, i);
    }
  }
  
  if (media_dir == null)
    media_dir = root;

  url = images_backoffice_url + '/mediam.cgi?function=upload_image';
  url += '&media_dir=' + media_dir.replace(/\s/g, '+');
  url += '&subsystem=' + subsystem;
  url += '&imageid=' + imageid;

  if (arguments.length > 2)
    url += '&m_imageid=' + arguments[2];

  window.open(url, "UploadImage", "resizable=yes,scrollbars=yes,width=670,height=350");
}

////////////////////////////////////////////////////////////////////////////////
//
// UploadImageSave
//
/////////////////////////////////////////////////////////////////////////////////

function UploadImageSave(imageid, media_dir, fname, desc, subsystem)
{
  var doc = window.opener.document;
  var imageList = doc.getElementById(imageid);
  var dirList = doc.getElementById('d:' + imageid);
  var imagePath = doc.getElementById('t:' + imageid);
  var imageDesc = doc.getElementById('a:' + imageid);
  var image_dir, i;

  if (dirList == null)  // popup window mode
  {
    if (!button_images)
    {
      i = media_dir.indexOf(slash);
      image_dir = i >= 0? media_dir.slice(i + 1) : "";
    }
    else
      image_dir = media_dir;

    if (imagePath == null)  // will be null in basic editing mode
      imagePath = doc.getElementById(imageid);
  
    if (fname.length > 0)
    {
      imagePath.value = image_dir.length > 0? image_dir + slash + fname : fname;
      
      if (imageDesc != null)
        imageDesc.value = desc;
    }

    // check for moreinfo imageid
    if (arguments.length > 5)
    {
      var m_imageid = arguments[5];
      var m_image = doc.getElementById('t:' + m_imageid);

      if (m_image == null)
        m_image = doc.getElementById(m_imageid);
      
      if (m_image.value.length == 0 || m_image.value == no_image)
      {
        if (fname.length > 0)
        {
          m_image.value = image_dir.length > 0? image_dir + slash + fname : fname;
          
          if ((imageDesc = doc.getElementById('a:' + m_imageid)) != null)
          imageDesc.value = desc;
        }
      }
    }
    
    window.close();
    return;
  }

  if (dirList != null)
  {
    var radio = doc.getElementById('rb1:' + imageid);
    var options = dirList.options;
    var index = -1;

    radio.checked = true;

    for (i = 0; i < options.length; i++)
    {
      if (options[i].value == media_dir)
      {
        options[i].selected = true;
        index = i;
        break;
      }
    }

    if (imageDesc != null)
      imageDesc.value = desc;

    // check for moreinfo imageid
    if (arguments.length > 5)
    {
      var m_imageid = arguments[5];
      var m_image = doc.getElementById('t:' + m_imageid);

      if (m_image.value.length == 0 || m_image.value == no_image)
      {
        dirList = doc.getElementById('d:' + m_imageid);
        dirList.selectedIndex = index;
        
        radio = doc.getElementById('rb1:' + m_imageid);
        radio.checked = true;

        if ((imageDesc = doc.getElementById('a:' + m_imageid)) != null)
        imageDesc.value = desc;
      }
    }
  }

  if (imageList != null)
  {
    var func = "RefreshImageList(";
    var args = new Array(4);
    var n = 0;

    args[n++] = '"' + imageid + '"';
    args[n++] = '"' + fname + '"';
    args[n++] = subsystem;

    if (arguments.length > 5)
    {
      var m_imageid = arguments[5];
      var m_imageList = doc.getElementById(m_imageid);

      if (m_imageList != null)
        args[n++] = '"' + m_imageid + '"';
    }

    for (i = 0; i < n; i++)
    {
      if (i > 0)
        func += ', ';

      func += args[i];
    }

    func += ')';

    window.opener.setTimeout(func, 20);
  }

  window.close();
}

////////////////////////////////////////////////////////////////////////////////
//
// ViewImage
//
/////////////////////////////////////////////////////////////////////////////////

function ViewImage(imageid, subsystem)
{
  var imageList = document.getElementById(imageid);
  var dirList = document.getElementById('d:' + imageid);
  var imagePath = document.getElementById('t:' + imageid);
  var radio1 = document.getElementById('rb1:' + imageid);
  var media_dir, image_name;
      
  if (radio1 != null && radio1.checked)
  {
    media_dir = dirList.options[dirList.selectedIndex].value;
    image_name = imageList.options[imageList.selectedIndex].text;
  }
  else
  {
    if (imagePath == null)  // will be null in basic editing mode
      imagePath = document.getElementById(imageid).value;
    else
      imagePath = imagePath.value;

    if (imagePath.match(/^http/i) != null)
    {
      window.open(imagePath, 'mediam', 'width=400,height=400,resizable=yes,scrollbars=yes');
      return;
    }

    if (button_images)
    {
      imagePath = images_url + '/' + imagePath;
      window.open(imagePath, 'mediam', 'width=400,height=400,resizable=yes,scrollbars=yes');
      return;
    }
    
    if (imagePath.match(/^\[shopsite-images\]/i) != null)
    {
      imagePath = images_url + imagePath.slice(17);
      window.open(imagePath, 'mediam', 'width=400,height=400,resizable=yes,scrollbars=yes');
      return;
    }

    if ((i = imagePath.lastIndexOf(slash)) >= 0)
    {
      image_name = imagePath.slice(i + 1);
      media_dir = imagePath.slice(0, i);
    }
    else
    {
      image_name = imagePath;
      media_dir = 'media';
    }

    if (media_dir.match(/^media/i) == null)
      media_dir = 'media' + slash + media_dir;
  }

  url = images_backoffice_url + '/mediam.cgi';
  url += '?view_image=1';
  url += '&imageid=' + imageid;
  url += '&media_dir=' + media_dir;
  url += '&subsystem=' + subsystem;
  url += '&image_name=' + image_name;

  window.open(url, 'mediam', 'width=700,height=600,resizable=yes,scrollbars=yes');
}

////////////////////////////////////////////////////////////////////////////////
//
// ChangeImage
//
/////////////////////////////////////////////////////////////////////////////////

function ChangeImage(imageid, subsystem)
{
  if (imageWindow != null && !imageWindow.closed)
    ViewImage(imageid, subsystem);
}

////////////////////////////////////////////////////////////////////////////////
//
// MakeURL
//
/////////////////////////////////////////////////////////////////////////////////

function MakeURL(imagePath, imageName, imageSize)
{
  var mediaDir = 'media/';
  var imageURL;

  imageURL = imagePath.replace(/\\/g, '/');

  if (imageURL == 'media')
    imageURL += '/';
  
  if (imageURL.substr(0, mediaDir.length) != mediaDir)
    imageURL = mediaDir + imageURL;

  if (imageSize > 0)
  {
    if (imageURL.match(/\/$/) == null)
      imageURL += '/';

    imageURL += 'ss_size' + imageSize;
  }

  imageURL = output_url + '/' + imageURL;

  if (imageURL.match(/\/$/) == null)
    imageURL += '/';

  return imageURL += imageName;
}

////////////////////////////////////////////////////////////////////////////////
//
// CheckRadioButton
//
/////////////////////////////////////////////////////////////////////////////////

function CheckRadioButton(buttonID)
{
  document.getElementById(buttonID).checked = true;

  if (arguments.length > 1)
  {
    // make the moreinfo image the same as the product image
    // if there isn't one already specified for it
    var m_imageid = arguments[1];
    var m_image = document.getElementById('t:' + m_imageid);

    if (m_image.value.length == 0 || m_image.value == no_image)
    {
      var i = buttonID.indexOf(':');
      var imageid = buttonID.slice(i + 1);

      RefreshMoreInfoImageList(imageid, m_imageid);
      document.getElementById('rb1:' + m_imageid).checked = true;
    }
  }
}

////////////////////////////////////////////////////////////////////////////////
//
// SelectImage (opens the popup window)
//
/////////////////////////////////////////////////////////////////////////////////

function SelectImage(imageid, subsystem)
{
  var image, url;
  var i;

  image = document.getElementById(imageid).value;

  if (image.substr(0, 4) == 'http')
  {
    i = image.indexOf('/media/');
    if (i > 0)
      image = image.substr(i + 7); 
  }
  else
  {
    // remove any ampersands from the image name
    parts = image.split('&');
    image = parts[0];
    for (i = 1; i < parts.length; i++)
      image += parts[i];
  }

  url = images_backoffice_url + '/mediam.cgi?popup=1';
  url += '&subsystem=' + subsystem;
  url += '&imageid=' + imageid;
  url += '&image=' + image;

  if (arguments.length > 2)
    url += '&m_imageid=' + arguments[2];

  window.open(url, 'mediam', 'width=700,height=630,resizable=yes,scrollbars=yes');
  return false;
}

////////////////////////////////////////////////////////////////////////////////
//
// files_selected
//
/////////////////////////////////////////////////////////////////////////////////

function files_selected()
{
  var files = document.getElementById('files');
  var image_size = document.getElementById('image_size');
  var selected_files = document.getElementById('selected_files');
  var selected_size = document.getElementById('selected_size');
  var i;

  if (files.selectedIndex < 0)
  {
    alert(select_a_file);
    return false;
  }

  if (selected_files != null)
  {
    selected_files.value = '|';

    for (i = 0; i < files.options.length; i++)
    {
      if (files.options[i].selected)
        selected_files.value += files.options[i].index + '|';
    }
  }

  if (image_size != null)
    selected_size.value = image_size.value;

  return true;
}

////////////////////////////////////////////////////////////////////////////////
//
// return_image
//
/////////////////////////////////////////////////////////////////////////////////

function return_image()
{
  var dirList = document.getElementById('directories');
  var fileList = document.getElementById('files');
  var image;

  if (files_selected())
  {
    var dirPath = dirList.options[dirList.selectedIndex].value;
    var selected_file = fileList.options[fileList.selectedIndex].value;

    if (subsystem != button_images)
    {
      if (dirPath.slice(0, root.length) == root)
        dirPath = dirPath.slice(root.length + 1);
    }

    if (dirPath.length > 0)
      dirPath = dirPath + slash;

    if ((image = window.opener.document.getElementById(imageid)) != null)
      image.value = dirPath + selected_file;

    if ((image = window.opener.document.getElementById(m_imageid)) != null)
    {
      if (image.value.length == 0 || image.value == none)
        image.value = dirPath + selected_file;
    }

    window.close();
  }
}

////////////////////////////////////////////////////////////////////////////////
//
// return_editor_image
//
/////////////////////////////////////////////////////////////////////////////////

function return_editor_image(tiny)
{
  var dirList  = document.getElementById('directories');
  var fileList = document.getElementById('files');
  var sizeList = document.getElementById('image_size');
  var root = 'media';
  var url;

  if (files_selected())
  {
    var dirPath = dirList.options[dirList.selectedIndex].value;
    var image_file = fileList.options[fileList.selectedIndex].value;
    var image_size = sizeList.options[sizeList.selectedIndex].value;

    if (dirPath.slice(0, root.length) == root)
      dirPath = dirPath.slice(root.length + 1);

    if (dirPath.length > 0)
      dirPath = dirPath + slash;

    url = backoffice_url + '/mediam.cgi?return_editor_image=1';
    url += '&image=' + dirPath + image_file;
    url += '&size=' + image_size;
    if (tiny != undefined) url += '&tinymce=1';

    document.location.replace(url);
  }

  return false;
}

////////////////////////////////////////////////////////////////////////////////
//
// view_image_size
//
/////////////////////////////////////////////////////////////////////////////////

function view_image_size(sizeid, media_dir)
{
  var image_num, image_name, image_url;
  var image_size, parts;
  var frame, link, size;
  var i;

  parts = sizeid.split(':');
  image_num = parts[0];
  image_size = Number(parts[1]);

  link = document.getElementById(sizeid);
  if (link.style.color == 'red')
  {
    alert(image_not_exist);
    return;
  }

  image_name = document.getElementById('name_' + image_num).value;
  image_url = output_url;

  if (image_size > 0)
    image_url += '/' + media_dir + '/' + 'ss_size' + image_size + '/' + image_name;
  else
    image_url += '/' + media_dir + '/' + image_name;

  image_url = image_url.replace(/\\/g, '/');

  frame = document.getElementById('frame_' + image_num);
  frame.src = image_url;

  for (i = 0; i <= 4; i++)
  {
    size = document.getElementById(image_num + ':' + i + 'size');
    size.style.display = i == image_size? '' : 'none';
  }

  for (i = 0; i < 4; i++)
  {
    link = document.getElementById(image_num + ':' + i);
    if (link.style.color !== 'red')
      link.style.color = 'blue';
  }

  link = document.getElementById(sizeid);
  link.style.color = 'green';
}

////////////////////////////////////////////////////////////////////////////////
//
// get_image_filenames
//
/////////////////////////////////////////////////////////////////////////////////

function get_image_filenames(media_dir, subsystem)
{
  var url = images_backoffice_url + "/mediam.cgi";
  url += "?media_filenames=" + media_dir;
  url += "&subsystem=" + subsystem;
  url += "&sid=" + Math.random();

  get_image_filenames.list = '';
  xmlHttpRequest(url, 'get_image_filenames');

  return get_image_filenames.list;
}

////////////////////////////////////////////////////////////////////////////////
//
// create_resized_images
//
/////////////////////////////////////////////////////////////////////////////////

function create_resized_images(resize_id, media_dir)
{
  var image_num, image_name;
  var parts, url, size;
  var i;

  parts = resize_id.split('_');
  image_num = parts[1];

  create_resized_images.image_num = image_num;
  create_resized_images.image_sizes = '';

  image_name = document.getElementById('name_' + image_num).value;

  url = images_backoffice_url + "/mediam.cgi";
  url += "?create_resized_images=" + image_name;
  url += "&media_dir=" + media_dir.replace(/\s/g, '+');
  url += "&sid=" + Math.random();

  xmlHttpRequest(url, 'create_resized_images');

  for (i = 0; i < 4; i++)
  {
    size = document.getElementById(image_num + ':' + i + 'size');
    size.innerText = create_resized_images.image_sizes[i];
  }
}

////////////////////////////////////////////////////////////////////////////////
//
// delete_image
//
/////////////////////////////////////////////////////////////////////////////////

function delete_image(delete_id, media_dir)
{
  var image_num, image_name, imageid = null;
  var parts, links, url, size;
  var i;

  if (window.confirm(are_you_sure) == false)
    return false;
  
  // The delete_id with an imageid is in this format: "delete_%d|%s"
  parts = delete_id.split('|');
  if (parts.length > 1)
  {
    // The imageid is included when the View button is clicked for a
    // selected image.
    imageid = parts[1];
    parts = parts[0].split('_');
    image_num = parts[1];  // this is used to get the image name
  }
  else
  {
    // The imageid is omitted when the View Image button is clicked in
    // the Select Image popup window.
    parts = delete_id.split('_');
    image_num = parts[1];
  }

  delete_image.imageid = imageid;
  delete_image.image_num = image_num;

  image_name = document.getElementById('name_' + image_num).value;

  url = images_backoffice_url + "/mediam.cgi";
  url += "?delete_image=" + image_name;
  url += "&media_dir=" + media_dir.replace(/\s/g, '+');
  url += "&sid=" + Math.random();

  xmlHttpRequest(url, 'delete_image');

  frame = document.getElementById('frame_' + image_num);
  frame.src = images_url + '/screen/redx.gif';

  if ((links = document.getElementById('links_' + image_num)) != null)
    links.style.visibility = 'hidden';

  if (imageid != null)
    reset_image_control(imageid);

  for (i = 0; i <= 4; i++)
  {
    size = document.getElementById(image_num + ':' + i + 'size');
    size.style.display = i < 4? 'none' : 'show';
  }

  return true;
}

////////////////////////////////////////////////////////////////////////////////
//
// reset_image_control
//
/////////////////////////////////////////////////////////////////////////////////

function reset_image_control(imageid)
{
  var doc = window.opener.document;
  var imageList = doc.getElementById(imageid);
  var dirList = doc.getElementById('d:' + imageid);
  var imagePath = doc.getElementById('t:' + imageid);
  var fname = '';

  if (imagePath == null)  // will be null in basic editing mode
    imagePath = doc.getElementById(imageid);

  imagePath.value = '';

  if (dirList != null)
  {
    var radio = doc.getElementById('rb2:' + imageid);
    radio.checked = true;
  }
  
  if (imageList != null)
  {
    var func = "RefreshImageList(";
    var args = new Array(3);
    var n = 0;

    args[n++] = '"' + imageid + '"';
    args[n++] = '"' + fname + '"';
    args[n++] = subsystem;

    for (i = 0; i < n; i++)
    {
      if (i > 0)
        func += ', ';

      func += args[i];
    }

    func += ')';
  
    window.opener.setTimeout(func, 20);
  }
}

////////////////////////////////////////////////////////////////////////////////
//
// reset_image_link_colors
//
/////////////////////////////////////////////////////////////////////////////////

function reset_image_link_colors(caller, color)
{
  var image_num, link;
  var i;

  switch (caller)
  {
    case 'create_resized_images':
      image_num = create_resized_images.image_num;
      break;

    case 'delete_image':
      if ((image_num = delete_image.image_num) != null)
      {
        link = document.getElementById(image_num + ':' + 0);
        if (link != null)
          link.style.color = color;
      }
      break;
  }

  for (i = 1; i <= 3; i++)
  {
    link = document.getElementById(image_num + ':' + i);
    if (link != null)
      link.style.color = color;
  }
}

////////////////////////////////////////////////////////////////////////////////
//
// image_file_exists
//
/////////////////////////////////////////////////////////////////////////////////

function image_file_exists(image_file, image_size)
{
  var url = images_backoffice_url + "/mediam.cgi";
  url += "?image_file_exists=" + image_file;
  url += "&media_dir=" + media_dir.replace(/\s/g, '+');
  url += "&image_size=" + image_size;
  url += "&sid=" + Math.random();

  image_file_exists.state = false;
  xmlHttpRequest(url, 'image_file_exists');

  return image_file_exists.state;
}

