(function($) {



$(window).load(function() 
{

if (typeof config != "undefined") {
  //$('input[name="Save Changes"]').click(function() {
  $('#button_save_changes').click(function() {
    //var max_length = parseInt($('input[name="max_length"]').val());
    $('form').validate({
      rules: {
        min_length: {
          required: "#reviews_enable:checked",
          digits: true
        },
        max_length: {
          required: "#reviews_enable:checked",
          digits: true,
          greaterThan: "#min_length"
        },
        max_stars: {
          required: "#reviews_enable:checked",
          digits: true,
          max:20,
          min:1
        },
        auto_stars: {
          required: "#approval-1:checked",
          digits: true,
          lessThanOrEqualTo: "#max_stars"
        },
        email_days: {
          required: "#email_enable",
          digits: true
        },
        summary_best: {
          required: "#summary_enable",
          digits: true
        },
        summary_worst: {
          required: "#summary_enable",
          digits: true
        },
        RV_ss_PageWidth: {
          digits: true
        },
        notify_email: {
          required: "#notify_pending:checked, #notify_approved:checked",
          email: true
        },
        recaptcha_site_key: {
          required: "#reviews_captcha_type-5:checked"
        },
        recaptcha_secret_key: {
          required: "#reviews_captcha_type-5:checked"
        }
      },
    
      /*errorPlacement: function(error, element) {
        error.prependTo( element.parent());
      },*/
      errorPlacement: function(error,element) {
        error.css({display:'block'});
        if(element.hasClass('cp_text')) element=element.parent();
        element.parent().append(error);
      },
    
      messages: {
        max_length: {
          greaterThan: "Must be larger than minimal length. "
        },
        auto_stars: {
          lessThanOrEqualTo: "Must not be larger than maximum number of stars. "
        }
      }
    
    });
  });
  
  
  $('input[name="reviews_captcha_type"]').change(function() {
    if ($('#reviews_captcha_type-5').is(':checked')) {
      $('#recaptcha_v2_config').css({display:'block'});
    } else {
      $('#recaptcha_v2_config').css({display:'none'});
    }
  });
  
  if ($('#reviews_captcha_type-5').is(':checked'))
    $('#recaptcha_v2_config').css({display:'block'});
  
  
} else {

  
  //var star = new Image();
  //star.src = background_star_path + "?" + Math.random();
  
  
  var state = {
    rating: 0
  }
  
  var status_matrix = {
    'approve': {status: 'Approved', link: 'Approved', classes: 'green', clickers: ['promote_positive', 'promote_negative', 'disapprove']},
    'disapprove': {status: 'Disapproved', link: 'Disapproved', classes: 'red', clickers: ['approve', 'promote_positive', 'promote_negative']},
    'promote_positive': {status: 'Featured, positive', link: 'Featured, positive', classes: 'green bold', clickers: ['approve', 'disapprove', 'promote_negative']},
    'promote_negative': {status: 'Featured, negative', link: 'Featured, negative', classes: 'green bold', clickers: ['approve', 'disapprove', 'promote_positive']}
  }
  
  //star.onload = function() 
  {
    //css();
    
    $('.reviews_star').hover(
      function() {
        state.rating = parseInt($(this).prevAll('.current_rating').val());
        var star_num = parseInt($(this).html());
        $(this).prevAll('.reviews_stars_rating').css({
          'width': ((star_num + 1)* 100) / max_stars + "%"
        });
      } , 
      function() {
        $(this).prevAll('.reviews_stars_rating').css({
          'width': state.rating + "%"
        });
      }
    );
    
    $('.reviews_star').click(function() {
      var rating = (parseInt($(this).html()) + 1) / max_stars * 100;
      $(this).prevAll('.current_rating').val(rating);
      $(this).prevAll('.rating').val(rating);
      state.rating = rating;
      $(this).parent().parent().find('.error').remove();
      //$(this).parent().prevAll('h4').html(t_your_rating + ":");
      //var top = $(this).closest("form");
      //$(top).validate().element(".rating");
    });

    
  }
  
  
 $('.reviews_submit').click(function() {
    var top = $(this).closest("form");
    var in_form = 1;
    if (top.length == 0) {
      in_form = 0;
      $(this).closest(".reviews_form").wrap('<form id=\"ser_form\"/>');
      top = $('#ser_form');
    }
    $(top).validate({
      ignore: [],
      errorClass: "field_warn",
      errorPlacement: function(error, element) {
        if (element.hasClass('rating'))
          element.parent().next().after(error);
        else
          element.next().after(error);
      },
      rules: {
        rating: {
          required: true,
          min: 1
        },
        reviews_area: {
          required: min_length > 0,
          minlength: min_length
        }
      },
      messages: {
        reviews_name: t_name_required,
        reviews_title: t_title_required,
        reviews_email: {
          required: t_email_required,
          email: t_email_wrong
        },
        rating: t_rating_required,
        reviews_area: t_review_length + min_length + t_characters
      }
    });
    if ($(top).valid()) {
      var data = "ajax=submit&" + $(top).serialize();
      //alert(data);
      var url = sb_rev_path + "/reviews.cgi";
      var submit_button = $(this).val();
      //alert(submit_button);
      $(this).val(t_working);
      $(this).attr("disabled", "disabled");
      
      //alert(data);
      
      $.ajax({
        type: 'POST',
        url: url,
        data: data,
        //contentType: "application/x-www-form-urlencoded;charset=ISO-8859-1",
        success:  function(response) {
          //alert(response);
          $('.reviews_submit').val(submit_button);
          $('.reviews_submit').removeAttr("disabled");    
          if (response.search("CAPTCHA error") == -1) {
            $(top).replaceWith(response);
          }
          else {
            $('.captcha_error').css('display', 'block');
            if (captcha_type == 4)
              ACPuzzle.reload('');
            else if (captcha_type == 3)
              Recaptcha.reload();
          }
          if (!in_form)
            $(top).find('.reviews_form').unwrap();
        } 
      });
    } else {
      $(window).scrollTop($(top).offset().top-100);
      if (!in_form)
        $(top).find('.reviews_form').unwrap();
      
    }
    
  });
  
  

  
  
  $('.decision_link').click(function() {
    
    
    var mass = false;
    var message = "";
    
    var decision="approve";
    if ($(this).hasClass('disapprove'))
      decision = "disapprove";
    if ($(this).hasClass('promote_positive'))
      decision = "promote_positive";
    if ($(this).hasClass('promote_negative'))
      decision = "promote_negative";
    if ($(this).hasClass('demote'))
      decision = "demote";
    if ($(this).hasClass('delete'))
      decision = "delete";
    
    if ($(this).hasClass('disapprove_all')) {
      decision = "disapprove_all";
      mass = true;
      message = "All reviews disapproved";
    }
    
    if ($(this).hasClass('approve_all')) {
      decision = "approve_all";
      mass = true;
      message = "All reviews approved";
    }
    
    if (mass) {
      var data = "ajax=1&decision="+decision;
      $('#all_reviews').replaceWith("<p class=reviews_message>" + message + "</p>");
      $(this).closest('.button_block').remove();
    } else {
      if (decision == 'delete')
        if (!confirm("Delete this review permanently?"))
          return;
      if (operation == 0 || decision == 'delete')
        $(this).closest('tr').remove();
      else {
        var status = $(this).parent().find('.status');
        $(status).html(status_matrix[decision].status);
        $(status).removeClass('green red bold').addClass(status_matrix[decision].classes);
        $(this).parent().find('.decision_link').addClass('hidden');
        for (var d in status_matrix[decision].clickers) {
          var clicker = $(this).parent().find('.'+status_matrix[decision].clickers[d]);
          $(clicker).removeClass('hidden');
          $(clicker).html(status_matrix[status_matrix[decision].clickers[d]].link);
        }
        $(this).parent().find('.delete').removeClass('hidden');
      }
      var id = $(this).parent().find('.review_id').val();
      var data = "ajax=1&decision="+decision+"&id="+id;
    }
    //alert(data);
    $.ajax({
      type: 'POST',
      url: 'reviews_bo.cgi',
      data: data,
      success:  function(response) {
        //alert(response);
        /*$('.reviews_submit').val(submit_button);
        $('.reviews_submit').removeAttr("disabled");    
        if (response.search("CAPTCHA error") == -1)
          $(top).html(response);
        else
          $('.captcha_error').css('display', 'block');*/
      } 
    });
  });
  
  
  $('.reviews_area').bind('paste keydown', function() { 
    var text = $(this).val(); 
    var len = text.length;
    if (len > max_length) {
      $(this).val(text.substr(0, max_length));
      len = max_length;
    }
    $(this).nextAll('.character_count').find('a').html(max_length - len);
  });
  
  
  
  
  
  
  
   $(function(){
                $('.all_reviews').scrollPagination({
                    'contentPage': sb_rev_path + "/reviews.cgi", // the page where you are searching for results
                    'contentData': 'ajax=load&storeid='+$('#storeid').val()+'&rec='+$('#rec').val()+'&GUID='+$('#GUID').val()+'&offset='+ $('.all_reviews').children().size(), // you can pass the children().size() to know where is the pagination
                    'scrollTarget': $(window), // who gonna scroll? in this example, the full window
                    'heightOffset': 10, // how many pixels before reaching end of the page would loading start? positives numbers only please
                    'beforeLoad': function(){ // before load, some function, maybe display a preloader div
                        //$('.loading').fadeIn();	
                        
                        this.contentData = 'ajax=load&storeid='+$('#storeid').val()+'&rec='+$('#rec').val()+'&GUID='+$('#GUID').val()+'&offset='+ $('.all_reviews').children().size();
                        //alert($('.all_reviews').children().size() + "|" + this.contentData);
                    },
                    'afterLoad': function(elementsLoaded){ // after loading, some function to animate results and hide a preloader div
                      
                      if ($(elementsLoaded).size() == 0)
                        $('.all_reviews').stopScrollPagination();
                         /*$('.loading').fadeOut();
                         var i = 0;*/
                      //$(elementsLoaded).fadeInWithDelay();
                      //css();
                    }
                });
                
                // code for fade in element by element with delay
                /*$.fn.fadeInWithDelay = function(){
                    var delay = 0;
                    return this.each(function(){
                        $(this).delay(delay).animate({opacity:1}, 200);
                        delay += 100;
                    });
                };*/
  });
  
  
}  
  
});



})(ss_jQuery);