
function validate()
{
  var ship_options, dimensions_option, containers;
  var product_name, weight, item_size;
  var recnums, recnum, i;

  recnums = product_recs.split(',');

  for (i = 0; i < recnums.length; i++)
  {
    recnum = recnums[i];

    weight = document.getElementsByName(elemName(recnum, weight_fieldnum));
    product_name = document.getElementsByName(elemName(recnum, name_fieldnum));
    item_size = document.getElementsByName(elemName(recnum, item_size_fieldnum));
    ship_options = document.getElementsByName(elemName(recnum, ship_options_fieldnum));

    if (product_name != undefined && product_name.length == 1)
    {
      if (product_name[0].value.length == 0)
      {
        alert(validate_msg1);
        product_name[0].focus();
        return false;
      }
    }

    if (item_size != undefined)
    {
      var d = elemName(recnum, item_size_fieldnum);
      var l = document.getElementById(d + ':l');
      var w = document.getElementById(d + ':w');
      var h = document.getElementById(d + ':h');

      if (check_dimensions(l, w, h) == false)
        return false;
    }
    
    if (ship_options != undefined && ship_options.length > 0)
    {
      var d = elemName(recnum, package_size_fieldnum);
      var s = elemName(recnum, ship_options_fieldnum);
      var l = document.getElementById(d + ':l');
      var w = document.getElementById(d + ':w');
      var h = document.getElementById(d + ':h');
      var x = document.getElementById(s + ':x');

      if (x.checked)
      {
        if (!(ship_options[0].checked || ship_options[1].checked))
        {
          focusOn(x);
          alert(select_dimensions);
          return false;
        }
      
        if (ship_options[0].checked)
        {
          if (l.value.length == 0 && w.value.length == 0 && h.value.length == 0)
          {
            focusOn(l);
            alert(validate_msg2);
            return false;
          }
        }
        else
        if (ship_options[1].checked)
        {
          var box_sizes = document.getElementsByName(elemName(recnum, box_sizes_fieldnum));
          if (box_sizes[0].selectedIndex == 0)
          {
            focusOn(box_sizes[0]);
            alert(validate_msg3);
            return false;
          }
        }
      }

      if (check_dimensions(l, w, h) == false)
        return false;
    }

    containers = document.getElementsByName(elemName(recnum, fedex_containers_fieldnum));
    if (containers != undefined && containers.length > 0)
    {
      if (weight == undefined || weight.length == 0)
        return confirm(validate_msg4);

      if (check_fedex_container(containers, weight) == false)
        return false;
    }

    containers = document.getElementsByName(elemName(recnum, usps_containers_fieldnum));
    if (containers != undefined && containers.length > 0)
    {
      if (weight == undefined || weight.length == 0)
        return confirm(validate_msg5);

      if (ship_options == undefined || ship_options.length == 0)
        return confirm(validate_msg5);

      var girth = document.getElementsByName(elemName(recnum, 'girth'));
      var have_dimensions = ship_options[0].checked || ship_options[1].checked;

      if (check_usps_container(containers, weight, girth, have_dimensions) == false)
        return false;
    }
  }

  return true;
}

function check_fedex_container(containers, weight)
{
  var index = containers[0].selectedIndex;
  var options = containers[0].options;
  var weight_limit_exceeded = false;
  var type, limit, text1, text2;

  if (index > 0)
  {
    type = options[index].value.slice(6);
    weight = Number(weight[0].value);

    if (type == 'ENVELOPE')
    {
      limit = 0.5;
      if (weight > limit)
        weight_limit_exceeded = true;
    }
    else
    if (type == 'PAK')
    {
      limit = 20.0;
      if (weight > limit)
        weight_limit_exceeded = true;
    }
    else
    if (type == '10KGBOX')
    {
      limit = 22.0;
      if (weight > limit)
        weight_limit_exceeded = true;
    }
    else
    if (type == '25KGBOX')
    {
      limit = 55.0;
      if (weight > limit)
        weight_limit_exceeded = true;
    }
    else
    {
      limit = 20.0;
      if (weight > limit)
        weight_limit_exceeded = true;
    }

    if (weight_limit_exceeded)
    {
      text1 = weight_limit_is + limit + pounds;
      text2 = fedex_msg1;
      focusOn(containers[0]);
      alert(options[index].text + ': ' + text1 + '\n' + text2);
      return false;
    }
  }

  return true;
}

function check_usps_container(containers, weight, girth, have_dimensions)
{
  var index = containers[0].selectedIndex;
  var options = containers[0].options;
  var text, value, type, units;

  if (index > 0)
  {
    text = options[index].text;

    if (text.indexOf('**') > 0)  // girth required
    {
      if (girth[0].value.length == 0)
      {
        focusOn(girth[0]);
        alert(usps_msg1);
        return false;
      }
    }

    if (text.indexOf('*') > 0)  // dimensions required
    {
      if (have_dimensions == false)
      {
        focusOn(containers[0]);
        alert(usps_msg2);
        return false;
      }
    }
  }

  if (index > 0 && text.indexOf('*') < 0)
  {
    weight = Number(weight[0].value);
    text = options[index].text;
    value = options[index].value;

    limit = (value == 'FLAT' || value == 'PARCEL')? 13/16 : 70.0;
    limit = (value == 'LETTER')? 3.5/16 : limit;

    if (weight > limit)
    {
      if (limit < 1.0)
      {
        limit = limit * 16;
        units = ounces;
      }
      else
        units = pounds;

      type = text.split(' *');
      focusOn(containers[0]);
      alert('USPS ' + type[0] + ': ' + weight_limit_is + limit + units);
      return false;
    }
  }

  return true;
}

function ship_singly(id)
{
  var option = document.getElementById(id);
  option.checked = true;
}

function elemName(recnum, field_id)
{
  return recnum + ':' + field_id;
}

