
function check_australia_post_config()
{
  if (check_weight('australia_post_max_pkg_weight') == false)
    return false;

  if (check_weight('australia_post_min_weight', 'australia_post_use_min_weight') == false)
    return false;

  if (check_weight('australia_post_min_order_weight', 'australia_post_use_min_order_weight') == false)
    return false;

  if (check_max_pkg_size() == false)
    return false;

  if (check_reserve_pkg_size() == false)
    return false;

  if (check_min_item_size() == false)
    return false;

  return true;
}

function check_weight(weight_id, use_id)
{
  var weight_elem = document.getElementById(weight_id);
  var weight_entered = weight_elem.value.length > 0;

  if (arguments.length > 1)
  {
    if (document.getElementById(use_id).checked)
    {
      if (!weight_entered)
      {
        weight_elem.focus();
        alert(enter_weight);
        return false;
      }
    }
  }

  if (isNaN(weight_elem.value))
  {
    weight_elem.focus();
    alert(weight_not_a_number);
    return false;
  }

  if (weight_entered && Number(weight_elem.value) <= 0)
  {
    weight_elem.focus();
    alert(invalid_weight);
    return false;
  }

  return true;
}

function check_max_pkg_size()
{
  var l = document.getElementById('australia_post_max_pkg_length');
  var w = document.getElementById('australia_post_max_pkg_width');
  var h = document.getElementById('australia_post_max_pkg_height');

  return check_dimensions(l, w, h);
}  

function check_reserve_pkg_size()
{
  var l = document.getElementById('australia_post_packing_material_length');
  var w = document.getElementById('australia_post_packing_material_width');
  var h = document.getElementById('australia_post_packing_material_height');

  return check_dimensions(l, w, h);
}  

function check_min_item_size()
{
  var l = document.getElementById('australia_post_min_item_length');
  var w = document.getElementById('australia_post_min_item_width');
  var h = document.getElementById('australia_post_min_item_height');

  if (document.getElementById('australia_post_use_min_item_size').checked)
  {
    if (l.value.length == 0 && w.value.length == 0 && h.value.length == 0)
    {
      l.focus();
      alert(enter_dimensions);
      return false;
    }
  }

  return check_dimensions(l, w, h);
}  

