
function check_dimensions(l, w, h)
{
  var length, width, height;  

  // check if any dimensions have been entered
  if (l.value.length > 0 || w.value.length > 0 || h.value.length > 0)
  {
    if (l.value.length == 0)
    {
      focusOn(l);
      alert(enter_length_dimension);
      return false;
    }

    if (w.value.length == 0)
    {
      focusOn(w);
      alert(enter_width_dimension);
      return false;
    }

    if (h.value.length == 0)
    {
      focusOn(h);
      alert(enter_height_dimension);
      return false;
    }

    // normalize decimal points
    length = l.value.replace(',', '.');
    width  = w.value.replace(',', '.');
    height = h.value.replace(',', '.');

    // must be valid numbers
    if (isNaN(length))
    {
      focusOn(l);
      alert(length_not_a_number);
      return false;
    }

    if (isNaN(width))
    {
      focusOn(w);
      alert(width_not_a_number);
      return false;
    }

    if (isNaN(height))
    {
      focusOn(h);
      alert(height_not_a_number);
      return false;
    }

    length = Number(length);
    width  = Number(width);
    height = Number(height);

    // cannot be zero or negative
    if (length <= 0)
    {
      focusOn(l);
      alert(invalid_dimension);
      return false;
    }

    if (width <= 0)
    {
      focusOn(w);
      alert(invalid_dimension);
      return false;
    }

    if (height <= 0)
    {
      focusOn(h);
      alert(invalid_dimension);
      return false;
    }

    // cannot be smaller than 0.01
    if (length < 0.01)
    {
      focusOn(l);
      alert(dimension_too_small);
      return false;
    }

    if (width < 0.01)
    {
      focusOn(w);
      alert(dimension_too_small);
      return false;
    }

    if (height < 0.01)
    {
      focusOn(h);
      alert(dimension_too_small);
      return false;
    }

    // length must be the larger dimension
    if (length < width || length < height)
    {
      focusOn(l);
      alert(length_must_be_greater);
      return false;
    }
  }

  return true;
}

function focusOn(element)
{
  var elem = $(element);

  if (elem.is(':hidden'))
    toggle_section(elem.closest('div.collapsible_section').prev().prev(), false);

  elem.focus();
}

