function get_ship_params(carrier_id)
{
  var params;
  var i;

  // Collect parameters to be passed to the configuration screen
  // for the selected shipping carrier.

  params = carrier_config[carrier_id];

  with (document.forms[0])
  {
    for (i = 0; i < shipmethod.length; i++)
    {
      if (shipmethod[i].checked == true)
      {
        params += '&shipmethod=' + shipmethod[i].value;
        break;
      }
    }

    for (i = 0; i < selfmt.length; i++)
    {
      if (selfmt[i].checked == true)
      {
        params += '&selfmt=' + selfmt[i].value;
        break;
      }
    }

    if (pro_store)
    {
      if (shipapi.checked == true)
        params += '&shipapi=' + shipapi.value;
    }

    if (ship_order.value.length > 0)
      params += '&ship_order=' + ship_order.value;

    if (ups_active.checked == true)
      params += '&ups_active=1';

    if (fedex_active.checked == true)
      params += '&fedex_active=1';

    if (usps_active.checked == true)
      params += '&usps_active=1';

    if (canada_post_active.checked == true)
      params += '&canada_post_active=1';

    if (australia_post_active.checked == true)
      params += '&australia_post_active=1';
  }

  return params;
}

function configure_carrier(carrier_id, carrier_name)
{
  var params = get_ship_params(carrier_id, carrier_name);
  var config_url;

  config_url = shipping_url + '/' + carrier_name + '.cgi?' + params;
  window.location.href = config_url;
}

function move_ship_item(incr)
{
  var items, text, value;
  var i, j, n;

  with (document.forms[0])
  {
    items = ship_items.options;
    i = ship_items.selectedIndex;
    if (i < 0)
    {
      alert(select_list_item);
      return false;
    }

    j = i + incr;
    n = items.length;

    if ((incr < 0 && j < 0) || (incr > 0 && j >= n))
      return false;

    text = items[j].text;
    value = items[j].value;
    items[j].text = items[i].text;
    items[j].value = items[i].value;
    items[i].text = text;
    items[i].value = value;

    items[i].selected = false;
    items[j].selected = true;

    update_ship_order();
  }

  return false;
}

function include_ship_item(checked, text, value)
{
  var items;
  var i, n;

  with (document.forms[0])
  {
    items = ship_items.options;
    n = items.length;
    
    for (i = 0; i < n; i++)
    {
      if (items[i].value == value)
        break;
    }

    if (checked)
    {
      if (i == n)
        items[i] = new Option(text, value, false, false);
    }
    else
    if (i < n)
      items[i] = null;

    update_ship_order();
  }
}

function update_ship_order()
{
  var items;
  var i, n;

  with (document.forms[0])
  {
    ship_order.value = '';
    items = ship_items.options;
    n = items.length;

    for (i = 0; i < n; i++)
    {
      if (i > 0)
        ship_order.value += '|';

      ship_order.value += items[i].value;
    }
  }
}

function add_box_size()
{
  var num_boxes = document.getElementById('standard_box_sizes');
  var num = Number(num_boxes.value);
  var table, input, col, dim, label;
  var i;

  var row = document.createElement('tr');
  var label = document.createElement('td');

  label.innerHTML = 'Box ' + Number(num + 1);
  row.appendChild(label);

  for (i = 0; i < 3; i++)
  {
    switch (i)
    {
      case 0:
        dim = '_length';
        break;

      case 1:
        dim = '_width';
        break;

      case 2:
        dim = '_height';
        break;
    }
  
    input = document.createElement('input');
    input.type = 'text';
    input.id = 'size' + num + dim;
    input.name = input.id;
    input.className = 'number';
    input.size = '6';
   
    col = document.createElement('td');
    col.appendChild(input);
    row.appendChild(col);
  }

  table = document.getElementById('box_sizes');
  table.appendChild(row);

  num_boxes.value = Number(num + 1);
  return false;
}

function validate_box_sizes()
{
  var num_boxes = document.getElementById('standard_box_sizes');
  var num = Number(num_boxes.value);
  var length, width, height;
  var i;

  for (i = 0; i < num; i++)
  {
    var l = document.getElementById('size' + i + '_length');
    var w = document.getElementById('size' + i + '_width');
    var h = document.getElementById('size' + i + '_height');

    length = l.value.replace(',', '.');
    width  = w.value.replace(',', '.');
    height = h.value.replace(',', '.');

    if (isNaN(length))
    {
      l.focus();
      alert(length_not_a_number);
      return false;
    }

    if (isNaN(width))
    {
      w.focus();
      alert(width_not_a_number);
      return false;
    }

    if (isNaN(height))
    {
      h.focus();
      alert(height_not_a_number);
      return false;
    }

    length = Number(length);
    width  = Number(width);
    height = Number(height);

    if (l.value.length > 0 || w.value.length > 0 || h.value.length > 0)
    {
      if (l.value.length == 0)
      {
        alert(enter_length_dimension);
        l.focus();
        return false;
      }
    
      if (w.value.length == 0)
      {
        alert(enter_width_dimension);
        w.focus();
        return false;
      }

      if (h.value.length == 0)
      {
        alert(enter_height_dimension);
        h.focus();
        return false;
      }

      if (length <= 0)
      {
        alert(invalid_dimension);
        l.focus();
        return false;
      }

      if (width <= 0)
      {
        alert(invalid_dimension);
        w.focus();
        return false;
      }

      if (height <= 0)
      {
        alert(invalid_dimension);
        h.focus();
        return false;
      }

      if (length < width || length < height)
      {
        alert(dimensions_warning);
        l.focus();
        return false;
      }
    }
  }

  return true;
}

function clear_box_sizes()
{
  var num_boxes = document.getElementById('standard_box_sizes');
  var num = Number(num_boxes.value);
  var i;

  for (i = 0; i < num; i++)
  {
    var l = document.getElementById('size' + i + '_length');
    var w = document.getElementById('size' + i + '_width');
    var h = document.getElementById('size' + i + '_height');

    l.value = '';
    w.value = '';
    h.value = '';
  }

  return false;
}

