
function delivery_type_changed(delivery_type)
{
  var home_delivery = document.getElementById('fedex_service1');
  var ground = document.getElementById('fedex_service2');

  if (delivery_type.value == 'residential')
  {
    if (ground.checked)
    {
      home_delivery.checked = true;
      ground.checked = false;
      alert(changed_to_home_delivery);
    }

  }
  else
  if (delivery_type.value == 'commercial')
  {
    if (home_delivery.checked)
    {
      home_delivery.checked = false;
      ground.checked = true;
      alert(changed_to_ground);
    }
  }
}

function service_tip(id)
{
  var service = document.getElementById('fedex_service' + id);
  var delivery_type = document.getElementsByName('fedex_delivery_type');
  var residential = delivery_type[0].checked;
  var commercial = delivery_type[1].checked;

  if (service.checked)
  {
    switch (id)
    {
      case 1:
        if (!residential)
        {
          service.checked = false;
          alert(service_msg_1);
        }
        break;

      case 2:
        if (!commercial)
        {
          service.checked = false;
          alert(service_msg_2);
        }
        break;
    }
  }
}

function check_fedex_config()
{
  if (check_weight('fedex_max_pkg_weight') == false)
    return false;

  if (check_weight('fedex_min_weight', 'fedex_use_min_weight') == false)
    return false;

  if (check_weight('fedex_min_order_weight', 'fedex_use_min_order_weight') == false)
    return false;

  if (check_rate_percent('fedex_account_rate_adjust') == false)
    return false;

  if (check_rate_percent('fedex_list_rate_adjust') == false)
    return false;

  if (check_dim_factors() == false)
    return false;

  if (check_max_pkg_size() == false)
    return false;

  if (check_reserve_pkg_size() == false)
    return false;

  if (check_min_item_size() == false)
    return false;

  if (check_smartpost() == false)
    return false;

  return true;
}

function check_weight(weight_id, use_id)
{
  var weight_elem = document.getElementById(weight_id);
  var weight_entered = weight_elem.value.length > 0;

  if (arguments.length > 1)
  {
    if (document.getElementById(use_id).checked)
    {
      if (!weight_entered)
      {
        weight_elem.focus();
        alert(enter_weight);
        return false;
      }
    }
  }

  if (isNaN(weight_elem.value))
  {
    weight_elem.focus();
    alert(weight_not_a_number);
    return false;
  }

  if (weight_entered && Number(weight_elem.value) <= 0)
  {
    weight_elem.focus();
    alert(invalid_weight);
    return false;
  }

  return true;
}

function check_rate_percent(percent_id)
{
  var percent_elem = document.getElementById(percent_id);
  var percent = percent_elem.value;

  if (percent.length > 0)
  {
    percent = Number(percent);
    if (isNaN(percent))
    {
      percent_elem.focus();
      alert(percent_not_a_number);
      return false;
    }
  }

  return true;
}

function check_smartpost()
{
  var enabled = document.getElementById(smartpost_id).checked;
  var hub = document.getElementById('fedex_smartpost_hub');

  if (enabled)
  {
    if (declared_value_check() == false)
      return false;

    if (hub.selectedIndex < 1)
    {
      alert(smartpost_hub);
      hub.focus();
      return false;
    }
  }

  return true;
}

function declared_value_check()
{
  var declared_value = document.getElementById('fedex_include_declared_value');
  if (declared_value.checked)
  {
    alert(smartpost_dv);
    declared_value.focus();
    return false;
  }
}

function check_dim_factors()
{
  var f1 = document.getElementById('fedex_dim_factor_domestic_in');
  var f2 = document.getElementById('fedex_dim_factor_domestic_cm');

  var f3 = document.getElementById('fedex_dim_factor_international_in');
  var f4 = document.getElementById('fedex_dim_factor_international_cm');

  var elem, i;

  for (i = 0; i < 4; i++)
  {
    switch (i)
    {
      case 0:
        elem = f1;
        break;

      case 1:
        elem = f2;
        break;

      case 2:
        elem = f3;
        break;

      case 3:
        elem = f4;
        break;
    }

    if (isNaN(elem.value))
    {
      elem.focus();
      alert(factor_not_a_number);
      return false;
    }

    if (elem.value.length > 0 && Number(elem.value) <= 0)
    {
      elem.focus();
      alert(invalid_factor);
      return false;
    }
  }

  return true;
}

function check_max_pkg_size()
{
  var l = document.getElementById('fedex_max_pkg_length');
  var w = document.getElementById('fedex_max_pkg_width');
  var h = document.getElementById('fedex_max_pkg_height');

  return check_dimensions(l, w, h);
}  

function check_reserve_pkg_size()
{
  var l = document.getElementById('fedex_packing_material_length');
  var w = document.getElementById('fedex_packing_material_width');
  var h = document.getElementById('fedex_packing_material_height');

  return check_dimensions(l, w, h);
}  

function check_min_item_size()
{
  var l = document.getElementById('fedex_min_item_length');
  var w = document.getElementById('fedex_min_item_width');
  var h = document.getElementById('fedex_min_item_height');

  if (document.getElementById('fedex_use_min_item_size').checked)
  {
    if (l.value.length == 0 && w.value.length == 0 && h.value.length == 0)
    {
      l.focus();
      alert(enter_dimensions);
      return false;
    }
  }

  return check_dimensions(l, w, h);
}  

function expand_format_codes()
{
  var format_codes = document.getElementById('format_codes');
  var image = document.getElementById('show_format_codes');
  var display = format_codes.style.display;
  var i = image.src.lastIndexOf('/') + 1;

  if (display == 'none')
  {
    format_codes.style.display = '';
    image.src = image.src.slice(0, i) + 'minus.gif';
  }
  else
  {
    format_codes.style.display = 'none';
    image.src = image.src.slice(0, i) + 'plus.gif';
  }
}

function expand_extension_note()
{
  var extension_note = document.getElementById('extension_note');
  var image = document.getElementById('show_extension_note');
  var display = extension_note.style.display;
  var i = image.src.lastIndexOf('/') + 1;

  if (display == 'none')
  {
    extension_note.style.display = '';
    image.src = image.src.slice(0, i) + 'minus.gif';
  }
  else
  {
    extension_note.style.display = 'none';
    image.src = image.src.slice(0, i) + 'plus.gif';
  }
}
  
