
function checkRegistrationInfo()
{
  var required_fields = new Array('contact_name', 'phone_number', 'email_address',
    'street_addrs1', 'city', 'postal_code', 'fedex_account_number');

  var field, value;
  var country, state;
  var digits = "0123456789";
  var digit_count;
  var digit;
  var i, j;

  // check for required info in text fields
  for (i = 0, j = 0; i < required_fields.length; i++)
  {
    field = document.getElementById(required_fields[i]);
    if (field.value.length == 0)
    {
      if (j == 0)
        field.focus();

      field.style.borderColor = 'red';
      j++;
    }
  }

  if (j > 0)
  {
    alert(fill_in_msg);
    return false;
  }

  country = document.getElementById('country');
  state = document.getElementById('state_province');

  if (country.selectedIndex < 0)
  {
    alert_msg(country, country_msg);
    return false;
  }

  if (state.selectedIndex < 1)
  {
    alert_msg(state, state_msg);
    return false;
  }

  // validate the email address
  field = document.getElementById('email_address');
  value = field.value;
  if (value.length > 0 && (value.indexOf('@', 0) == -1 || value.indexOf('.', 0) == -1))
  {
    alert_msg(field, email_msg);
    return false;
  }

  // validate the phone number
  field = document.getElementById('phone_number');
  value = field.value;
  if (value.length > 0)
  {
    digit_count = 0;
    for (i = 0; i < value.length; i++)
    {
      digit = value.substring(i, i + 1);
      if (digits.indexOf(digit) != -1)
        digit_count++;
    }

    if (digit_count < 10 || digit_count > 16)
    {
      alert_msg(field, phone_msg);
      return false;
    }
  }

  // validate the fax number
  field = document.getElementById('fax_number');
  value = field.value;
  if (value.length > 0)
  {
    digit_count = 0;
    for (i = 0; i < value.length; i++)
    {
      digit = value.substring(i, i + 1);
      if (digits.indexOf(digit) != -1)
        digit_count++;
    }

    if (digit_count < 10 || digit_count > 16)
    {
      alert_msg(field, fax_msg);
      return false;
    }
  }

  // validate the account number
  field = document.getElementById('fedex_account_number');
  value = field.value;
  if (value.length > 0)
  {
    digit_count = 0;
    for (i = 0; i < value.length; i++)
    {
      digit = value.substring(i, i + 1);
      if (digits.indexOf(digit) != -1)
        digit_count++;
    }

    if (digit_count < 9)
    {
      alert_msg(field, account_msg);
      return false;
    }
  }

  return true;
}

function alert_msg(field, msg)
{
  alert(msg);
  field.style.borderColor = 'red';
  field.focus();
}

