
function check_ups_config()
{
  if (check_weight('ups_max_pkg_weight') == false)
    return false;

  if (check_weight('ups_min_weight', 'ups_use_min_weight') == false)
    return false;

  if (check_weight('ups_min_order_weight', 'ups_use_min_order_weight') == false)
    return false;

  if (check_rate_adjust('ups_rate_adjust', 'ups_rate_percent') == false)
    return false;

  if (check_dim_factors() == false)
    return false;

  if (check_max_pkg_size() == false)
    return false;

  if (check_reserve_pkg_size() == false)
    return false;

  if (check_min_item_size() == false)
    return false;

  return true;
}

function check_weight(weight_id, use_id)
{
  var weight_elem = document.getElementById(weight_id);
  var weight_entered = weight_elem.value.length > 0;

  if (arguments.length > 1)
  {
    if (document.getElementById(use_id).checked)
    {
      if (!weight_entered)
      {
        weight_elem.focus();
        alert(enter_weight);
        return false;
      }
    }
  }

  if (isNaN(weight_elem.value))
  {
    weight_elem.focus();
    alert(weight_not_a_number);
    return false;
  }

  if (weight_entered && Number(weight_elem.value) <= 0)
  {
    weight_elem.focus();
    alert(invalid_weight);
    return false;
  }

  return true;
}

function check_rate_adjust(rate_adjust, rate_percent)
{
  var percent_elem = document.getElementById(rate_percent);
  var adjust_elem = document.getElementById(rate_adjust);
  var percent = percent_elem.value;

  percent = Number(percent.replace(',', '.'));

  if (isNaN(percent))
  {
    percent_elem.focus();
    alert(percent_not_a_number);
    return false;
  }

  if (adjust_elem.checked && percent == 0)
  {
    alert(enter_percent_adjust);
    percent_elem.focus();
    return false;
  }

  return true;
}

function rate_not_allowed(choice, current_rate_id)
{
  var rate = document.getElementById(current_rate_id);
  alert(account_required);
  choice.checked = false;
  rate.checked = true;
  rate.focus();
}

function check_dim_factors()
{
  var f1 = document.getElementById('ups_dim_factor_domestic_in');
  var f2 = document.getElementById('ups_dim_factor_domestic_cm');

  var f3 = document.getElementById('ups_dim_factor_us_canada_in');
  var f4 = document.getElementById('ups_dim_factor_us_canada_cm');

  var f5 = document.getElementById('ups_dim_factor_canada_us_in');
  var f6 = document.getElementById('ups_dim_factor_canada_us_cm');

  var f7 = document.getElementById('ups_dim_factor_international_in');
  var f8 = document.getElementById('ups_dim_factor_international_cm');

  var elem, i;

  for (i = 0; i < 8; i++)
  {
    switch (i)
    {
      case 0:
        elem = f1;
        break;

      case 1:
        elem = f2;
        break;

      case 2:
        elem = f3;
        break;

      case 3:
        elem = f4;
        break;

      case 4:
        elem = f5;
        break;

      case 5:
        elem = f6;
        break;

      case 6:
        elem = f7;
        break;

      case 7:
        elem = f8;
        break;
    }

    if (isNaN(elem.value))
    {
      elem.focus();
      alert(factor_not_a_number);
      return false;
    }

    if (elem.value.length > 0 && Number(elem.value) <= 0)
    {
      elem.focus();
      alert(invalid_factor);
      return false;
    }
  }

  return true;
}

function check_max_pkg_size()
{
  var l = document.getElementById('ups_max_pkg_length');
  var w = document.getElementById('ups_max_pkg_width');
  var h = document.getElementById('ups_max_pkg_height');

  return check_dimensions(l, w, h);
}  

function check_reserve_pkg_size()
{
  var l = document.getElementById('ups_packing_material_length');
  var w = document.getElementById('ups_packing_material_width');
  var h = document.getElementById('ups_packing_material_height');

  return check_dimensions(l, w, h);
}  

function check_min_item_size()
{
  var l = document.getElementById('ups_min_item_length');
  var w = document.getElementById('ups_min_item_width');
  var h = document.getElementById('ups_min_item_height');

  if (document.getElementById('ups_use_min_item_size').checked)
  {
    if (l.value.length == 0 && w.value.length == 0 && h.value.length == 0)
    {
      l.focus();
      alert(enter_dimensions);
      return false;
    }
  }

  return check_dimensions(l, w, h);
}  

